<script>
    export default{
        data(){
            return {
                primary:'primary',
                justified:true
            }
        }
    }
</script>

# buttonGroup

:::demo
```html
<template>
<button-group>
    <i-button :color="primary">Left</i-button>
    <i-button :color="primary">Middle</i-button>
    <i-button :color="primary">Right</i-button>
</button-group>
<br>
<br>
<h3>justified</h3>
<button-group :justified="justified">
    <a href="javascript:;" class="btn btn-danger">Left</a>
    <a href="javascript:;" class="btn btn-danger">Middle</a>
    <a href="javascript:;" class="btn btn-danger">Right</a>
</button-group>

</template>
<script>
    export default{
        data(){
            return {
                primary:'primary',
                justified:true
            }
        }
    }
</script>
```
:::

### Button Group Attributes
| 参数      | 说明          | 类型      | 可选值       | 默认值  |
|---------- |------------- |---------------|------------  |-------- |
| justified | 合理分配按钮大小 | `Boolean` | `true` 或 `false` | false |
