<script>
    export default {
        data(){
            return {
                checked:true
            }
        },
        methods:{
            onChange(e){
                // console.log("change...",e)
            }
        }
    }
</script>

# Checkbox

:::demo
```html
<checkbox :checked="checked" @change.native="onChange">赤</checkbox>

<script>
    export default {
        data(){
            return {
                checked:true
            }
        },
        methods:{
            onChange(e){
                // console.log("change...",e)
            }
        }
    }
</script>
```
:::

### Checkbox Attributes
| 参数      | 说明          | 类型      | 可选值       | 默认值  |
|---------- |------------- |---------------|------------  |-------- |
| checked | 是否选中 | `Boolean` | — | — |