import Vue from 'vue'

import router from './route.config.js'

import ZhidianUi from 'main/index.js'

import store from './store.js'

import '../packages/theme-default/lib/index.css'

import 'plugins/prism.min.js'

import App from './App.vue'

import demoBlock from './components/demo-block.vue';
import sideNav from './components/side-nav'

// 导入网易云信SDK
import SDK from 'plugins/NIM/js/NIM_Web_SDK_v4.0.0.js'

window.SDK = SDK
window.store = store

Vue.use(ZhidianUi)

Vue.component('demo-block', demoBlock);
Vue.component('side-nav', sideNav);

new Vue({
  store,
  router,
  template: '<App/>',
  components: { App }
}).$mount('#app')
