'use strict';

exports.__esModule = true;
exports.updateBlack = updateBlack;
function updateBlack(_ref, _ref2) {
  var state = _ref.state;
  var account = _ref2.account,
      isBlack = _ref2.isBlack,
      callback = _ref2.callback;

  var nim = state.nim;
  if (account && typeof isBlack === 'boolean') {
    nim.markInBlacklist({
      account: account,
      // `true`表示加入黑名单, `false`表示从黑名单移除
      isAdd: isBlack,
      done: callback
    });
  }
}