'use strict';

exports.__esModule = true;

var _cookie = require('./cookie.js');

var _cookie2 = _interopRequireDefault(_cookie);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  install: function install(Vue) {
    Vue.prototype.$cookie = this;
    Vue.cookie = this;
  },
  set: function set(name, value) {
    _cookie2.default.setCookie(name, value);
  },
  get: function get(name) {
    _cookie2.default.readCookie(name);
  },
  del: function del(name) {
    _cookie2.default.delCookie(name);
  }
};