import DateTimePicker from './src/datetimepicker'
import ObjectAssign from 'object-assign'

export default {
  install(Vue) {
      Vue.prototype.$dateTime = this
      Vue.dateTime = this
    },
    show(options = {}) {
      if(this.datetime){
        this.datetime.destroy()
      }
      options = ObjectAssign({
        destroyOnHide: true
      }, options)

      const datetime = this.datetime = new DateTimePicker(options)
      datetime.show()
    },
    hide: function() {
      this.datetime && this.datetime.hide()
    }
}
