// not a good way but works well
window.__$Popups = window.__$Popups || {}
const popupDialog = function(option) {
  this.uuid = Math.random().toString(36).substring(3, 8)
  this.params = {}
  this.isShow = false
  if (Object.prototype.toString.call(option) === '[object Object]') {
    this.params = {
      input: option.input || '',
      container: document.querySelector(option.input) || '',
      innerHTML: option.innerHTML || '',
      hideOnBlur: option.hideOnBlur,
      //背景面板
      mask: option.mask,
      onOpen: option.onOpen || function() {},
      onClose: option.onClose || function() {},
      reverse: option.reverse
    }
  }
  if (!!document.querySelectorAll('.popup-mask').length <= 0 && this.params.mask) {
    this.divMask = document.createElement('a')
    this.divMask.className = 'popup-mask'
    this.divMask.dataset.uuid = '' // 用于多个popup共享一个mask
    this.divMask.href = 'javascript:void(0)'

    this.divMask.addEventListener('touchmove', function(ev){
      ev.stopPropagation()
      ev.preventDefault()
    })

    document.body.appendChild(this.divMask)
  }
  let div
  if (!option.container) {
    div = document.createElement('div')
  } else {
    div = option.container
  }

  div.className = 'popup-dialog popup-dialog-' + this.uuid

  this.div = div

  if (!option.container) {
    document.body.appendChild(div)
  }
  this.container = document.querySelector('.popup-dialog-' + this.uuid)

  if (this.params.mask) {
    this.mask = document.querySelector('.popup-mask')
    this.mask.dataset.uuid += `,${this.uuid}`
  }

  this._bindEvents()
  option = null
  return this
}

popupDialog.prototype.onClickMask = function() {
  if (this.params.hideOnBlur && this.isShow) {
    this.hide(false)
  }
}

popupDialog.prototype._bindEvents = function() {
  this.params.mask && this.params.hideOnBlur && this.mask.addEventListener('click', this.onClickMask.bind(this), false)
}

popupDialog.prototype.show = function() {
  if (this.params.reverse) {
    this.container.classList.add('popup-reverse')
  }
  this.params.mask && this.mask.classList.add('popup-show')
  this.container.classList.add('popup-show')
  if (this.container.classList.contains('popup')) {
    this.container.classList.remove('popup')
    this.container.classList.add('popup-dialog')
    this.container.classList.add('popup-dialog' + this.uuid)
  }
  this.params.onOpen && this.params.onOpen(this)
  this.isShow = true
  window.__$Popups[this.uuid] = 1
}

popupDialog.prototype.hide = function(shouldCallback = true) {
  // if (this.params.reverse) {
  //   this.container.classList.remove('popup-reverse')
  // }
  this.container.classList.remove('popup-show')
  if (!document.querySelector('.popup-dialog.popup-show')) {
    this.params.mask && this.mask.classList.remove('popup-show')
  }
  if (this.container.classList.contains('popup')) {
    this.container.classList.remove('popup')
    this.container.classList.add('popup-dialog')
    this.container.classList.add('popup-dialog' + this.uuid)
  }
  shouldCallback === false && this.params.onClose && this.params.hideOnBlur && this.params.onClose(this)
  this.isShow = false
  delete window.__$Popups[this.uuid]
}

popupDialog.prototype.html = function(html) {
  this.container.innerHTML = html
}

popupDialog.prototype.destroy = function() {
  if (this.params.mask) {
    this.mask.dataset.uuid = this.mask.dataset.uuid.replace(new RegExp(`,${this.uuid}`, 'g'), '')
  }
  if (this.params.mask && !this.mask.dataset.uuid) {
    this.mask.removeEventListener('click', this.onClickMask.bind(this), false)
    this.mask && this.mask.parentNode && this.mask.parentNode.removeChild(this.mask)
  } else {
    this.hide()
  }
  delete window.__$Popups[this.uuid]
}

export default popupDialog
