// onSessions只在初始化完成后回调
export function onSessions ({state, commit, dispatch}, sessions) {
  // console.log("onSessions::::",sessions)
  commit('updateSessions', sessions)
}

export function onUpdateSession ({state, commit, dispatch} ,session) {
  // if(!!session.lastMsg){
  //   if('in' === session.lastMsg.flow){
  //     session.id = session.lastMsg.scene + "-" + session.lastMsg.from
  //   } else if('out' === session.lastMsg.flow){
  //     session.id = session.lastMsg.scene + "-" + session.lastMsg.target
  //   }
  // }
  let sessions = [session]
  commit('updateSessions', sessions)
}


export function setCurrSession ({state, commit, dispatch}, sessionId) {
  const nim = state.nim
  if (sessionId) {
    commit('updateCurrSessionId', {
      type: 'init',
      sessionId
    })
    if (nim) {
      // 如果在聊天页面刷新，此时还没有nim实例，需要在onSessions里同步
      nim.setCurrSession(sessionId)
      commit('updateCurrSessionMsgs', {
        type: 'init',
        sessionId
      })
      // 发送已读回执
      dispatch('sendMsgReceipt')
    }
  }
}

export function resetCurrSession ({state, commit}) {
  // console.log('resetCurrSession :::: 方法出发')
  const nim = state.nim
  nim.resetCurrSession()
  // console.log('updateCurrSessionMsgs :::: destroy')
  commit('updateCurrSessionMsgs', {
    type: 'destroy'
  })
}