import { createTest, createVue, destroyVM } from '../util';

import Flexbox from 'packages/flexbox'

describe('Flexbox', () => {
  let vm;
  afterEach(() => {
    destroyVM(vm);
  });

  it('orient vertical', () => {
    vm = createTest(Flexbox, {
      orient: 'vertical'
    }, true);
    expect(vm.$el.classList.contains('flex-col')).to.true;
  });

  it('orient horizontal', () => {
    vm = createTest(Flexbox, {
      orient: 'horizontal'
    }, true);
    expect(vm.$el.classList.contains('flex-row')).to.true;
  });

})
