import { createTest, createVue, destroyVM } from '../util';

import FlexboxItem from 'packages/flexboxItem'

describe('FlexboxItem', () => {
  let vm;
  afterEach(() => {
    destroyVM(vm);
  });

  it('flexboxItem span', () => {
    vm = createTest(FlexboxItem, {
      span: '3'
    }, true);
    assert.equal(-1, [1,2,3].indexOf(4));
  });

  // it('flexboxItem order', () => {
  //   vm = createTest(FlexboxItem, {
  //     order: 'flex'
  //   }, true);
  //   expect(vm.$el.classList.contains('flex-row')).to.true;
  // });

})
