<script>
    export default{
        data(){
            return {
                otherParams:{
                    token:'iR1Z8gKdzNheJ4dp6_ueY8wia2g8i59D9QLOxBnx:LgeXReaRKXKFn4zIaRjZcGfThOk=:eyJlbmRVc2VyIjoiU1lTVEVNIiwic2F2ZUtleSI6IiQoeWVhcikkKG1vbikkKGRheSkvJChlbmRVc2VyKV8kKGhvdXIpJChtaW4pJChzZWMpLyQoZm5hbWUpIiwic2NvcGUiOiJpbWFnZSIsImRlYWRsaW5lIjoxNDk5MDg2ODU5fQ=='
                },
                url:'http://up-z2.qiniu.com/'
            }
        },
        methods:{
            success(data){
                // console.log("success...",data)
            },
            fail(data){
                // console.log("fail...",data)
            }
        }
    }
</script>
# UploadHeadPic

:::demo
```html
<upload-head-pic :crop-width="640" :crop-height="640" :width="100" :height="100" :src="'http://img3.imgtn.bdimg.com/it/u=3193006289,3802606706&fm=26&gp=0.jpg'" :other-params="otherParams" :url="url" @crop-upload-success="success" @crop-upload-fail="fail"></upload-head-pic>
<script>
    export default{
        data(){
            return {
                otherParams:{
                    token:'iR1Z8gKdzNheJ4dp6_ueY8wia2g8i59D9QLOxBnx:LgeXReaRKXKFn4zIaRjZcGfThOk=:eyJlbmRVc2VyIjoiU1lTVEVNIiwic2F2ZUtleSI6IiQoeWVhcikkKG1vbikkKGRheSkvJChlbmRVc2VyKV8kKGhvdXIpJChtaW4pJChzZWMpLyQoZm5hbWUpIiwic2NvcGUiOiJpbWFnZSIsImRlYWRsaW5lIjoxNDk5MDg2ODU5fQ=='
                },
                url:'http://up-z2.qiniu.com/'
            }
        },
        methods:{
            success(data){
                // console.log("success...",data)
            },
            fail(data){
                // console.log("fail...",data)
            }
        }
    }
</script>
```
:::


### UploadHeadPic Attributes
| 参数      | 说明          | 类型      | 可选值       | 默认值  |
|---------- |------------- |---------------|------------  |-------- |
| width | 宽 | `Number` | — | — |
| height | 高 | `Number` | — | — |
| src | 图片地址 | `String` | — | 必填 |
| otherParams | 上传图片时，附加参数 | `Object` | — | — |
| url | 图片上传地址 | `String` | — | 必填 |
| cropWidth | 图片需要裁切的宽 | `Number` | — | 必填 |
| cropHeight | 图片需要裁切的高 | `Number` | — | 必填 |



### UploadHeadPic Events
| 名称      |  参数       | 描述 |
|---------- |------------- |---------------|
| crop-upload-success | (Params) | 裁切上传成功 |
| crop-upload-fail | (Params) | 裁切上传失败 |


