module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/dist/";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 250);
/******/ })
/************************************************************************/
/******/ ({

/***/ 1:
/***/ (function(module, exports) {

/* globals __VUE_SSR_CONTEXT__ */

// IMPORTANT: Do NOT use ES2015 features in this file.
// This module is a runtime utility for cleaner component module output and will
// be included in the final webpack user bundle.

module.exports = function normalizeComponent (
  rawScriptExports,
  compiledTemplate,
  functionalTemplate,
  injectStyles,
  scopeId,
  moduleIdentifier /* server only */
) {
  var esModule
  var scriptExports = rawScriptExports = rawScriptExports || {}

  // ES6 modules interop
  var type = typeof rawScriptExports.default
  if (type === 'object' || type === 'function') {
    esModule = rawScriptExports
    scriptExports = rawScriptExports.default
  }

  // Vue.extend constructor export interop
  var options = typeof scriptExports === 'function'
    ? scriptExports.options
    : scriptExports

  // render functions
  if (compiledTemplate) {
    options.render = compiledTemplate.render
    options.staticRenderFns = compiledTemplate.staticRenderFns
    options._compiled = true
  }

  // functional template
  if (functionalTemplate) {
    options.functional = true
  }

  // scopedId
  if (scopeId) {
    options._scopeId = scopeId
  }

  var hook
  if (moduleIdentifier) { // server build
    hook = function (context) {
      // 2.3 injection
      context =
        context || // cached call
        (this.$vnode && this.$vnode.ssrContext) || // stateful
        (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext) // functional
      // 2.2 with runInNewContext: true
      if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__
      }
      // inject component styles
      if (injectStyles) {
        injectStyles.call(this, context)
      }
      // register component module identifier for async chunk inferrence
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier)
      }
    }
    // used by ssr in case component is cached and beforeCreate
    // never gets called
    options._ssrRegister = hook
  } else if (injectStyles) {
    hook = injectStyles
  }

  if (hook) {
    var functional = options.functional
    var existing = functional
      ? options.render
      : options.beforeCreate

    if (!functional) {
      // inject component registration as beforeCreate hook
      options.beforeCreate = existing
        ? [].concat(existing, hook)
        : [hook]
    } else {
      // for template-only hot-reload because in that case the render fn doesn't
      // go through the normalizer
      options._injectStyles = hook
      // register for functioal component in vue file
      options.render = function renderWithStyleInjection (h, context) {
        hook.call(context)
        return existing(h, context)
      }
    }
  }

  return {
    esModule: esModule,
    exports: scriptExports,
    options: options
  }
}


/***/ }),

/***/ 22:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _popup = __webpack_require__(42);

var _popup2 = _interopRequireDefault(_popup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var timer = void 0; //
//
//
//
//
//
//

var touchstartFun = function touchstartFun() {
  var top = document.body.scrollTop,
      totalScroll = document.body.scrollHeight,
      currentScroll = top + document.body.offsetHeight;
  if (top === 0) {
    document.body.scrollTop = 1;
  } else if (currentScroll === totalScroll) {
    document.body.scrollTop = top - 1;
  }
};

var touchmoveFun = function touchmoveFun(evt) {
  if (document.body.offsetHeight > document.body.scrollHeight) {
    evt.preventDefault();
  }
};

exports.default = {
  name: 'Popup',
  props: {
    value: Boolean,
    height: {
      type: String,
      default: 'auto'
    },
    hideOnBlur: {
      type: Boolean,
      default: true
    },
    reverse: {
      type: Boolean,
      default: false
    },
    mask: {
      type: Boolean,
      default: true
    },
    historyModel: {
      type: Boolean,
      default: false
    }
  },
  mounted: function mounted() {
    var _this2 = this;

    window.removeEventListener("popstate", this.popupStateCallback, false);
    window.addEventListener("popstate", this.popupStateCallback, false);
    this.$nextTick(function () {
      var _this = _this2;
      _this2.popup = new _popup2.default({
        container: _this.$el,
        innerHTML: '',
        reverse: _this.reverse,
        hideOnBlur: _this.hideOnBlur,
        mask: _this.mask,
        onOpen: function onOpen() {
          _this.fixSafariOverflowScrolling('auto');

          _this.show = true;
        },
        onClose: function onClose() {
          _this.show = false;

          if (Object.keys(window.__$Popups).length >= 1) return;
          _this.fixSafariOverflowScrolling('touch');
        }
      });
      _this2.$overflowScrollingList = document.querySelectorAll('.fix-safari-overflow-scrolling');
    });
  },

  computed: {
    transitionStyle: function transitionStyle() {
      if (this.reverse) {
        return 'popup-animate-reverse';
      } else {
        return 'popup-animate';
      }
    },
    classes: function classes() {
      if (this.reverse) {
        return "popup popup-reverse";
      } else {
        return "popup";
      }
    },
    styles: function styles() {
      if (this.height.indexOf('%') != -1) {
        return 'height:' + this.height;
      } else {
        return 'height:' + this.height + 'px';
      }
    }
  },
  methods: {
    /**
     * https://github.com/airyland/vux/issues/311
     * https://benfrain.com/z-index-stacking-contexts-experimental-css-and-ios-safari/
     */
    fixSafariOverflowScrolling: function fixSafariOverflowScrolling(type) {
      if (!this.$overflowScrollingList.length) return;
      if (!/iphone/i.test(navigator.userAgent)) return;
      for (var i = 0; i < this.$overflowScrollingList.length; i++) {
        this.$overflowScrollingList[i].style.webkitOverflowScrolling = type;
      }
    },
    popupStateCallback: function popupStateCallback() {
      this.clickGoBack = true;
      this.show = false;
    }
  },
  data: function data() {
    return {
      hasFirstShow: false,
      show: this.value,
      clickGoBack: false
    };
  },

  watch: {
    show: function show(val) {
      this.$emit('input', val);
      if (val) {
        this.popup.show();
        this.$emit('on-show');
        this.clickGoBack = false;
        if (this.historyModel) {
          window.history.pushState(null, null, "#popupShow");
          // location.hash = '#popupShow'
        }

        if (!this.hasFirstShow) {
          this.$emit('on-first-show');
          this.hasFirstShow = true;
        }
      } else {
        this.popup.hide(false);
        this.$emit('on-hide');

        if (!this.clickGoBack && this.historyModel) {
          window.history.back();
        }
      }
      /**
       * 禁止背景滑动
       */

      if (this.mask) {
        clearTimeout(timer);

        timer = setTimeout(function () {
          if (!!document.body.querySelector('.popup-mask.popup-show')) {
            window.document.body.style.overflow = 'hidden';
            window.document.body.style.position = 'relative';
          } else {
            window.document.body.style.overflow = 'scroll';
            window.document.body.style.position = 'initial';
          }
          if (!!navigator.userAgent.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/)) {
            if (val) {
              document.body.addEventListener('touchstart', touchstartFun);
              document.body.addEventListener('touchmove', touchmoveFun);
            } else {
              document.body.removeEventListener('touchstart', touchstartFun);
              document.body.removeEventListener('touchmove', touchmoveFun);
            }
          }
        }, 200);
      }
    },
    value: function value(val) {
      this.show = val;
    }
  },
  beforeDestroy: function beforeDestroy() {
    this.popup.destroy();
    this.fixSafariOverflowScrolling('touch');
  }
};

/***/ }),

/***/ 250:
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(40);


/***/ }),

/***/ 40:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;

var _popup = __webpack_require__(41);

var _popup2 = _interopRequireDefault(_popup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_popup2.default.install = function (Vue) {
  Vue.component(_popup2.default.name, _popup2.default);
};

exports.default = _popup2.default;

/***/ }),

/***/ 41:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_popup_vue__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_popup_vue___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_popup_vue__);
/* harmony namespace reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_popup_vue__) if(__WEBPACK_IMPORT_KEY__ !== 'default') (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_popup_vue__[key]; }) }(__WEBPACK_IMPORT_KEY__));
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_508e75ca_hasScoped_false_preserveWhitespace_false_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_popup_vue__ = __webpack_require__(43);
var normalizeComponent = __webpack_require__(1)
/* script */


/* template */

/* template functional */
var __vue_template_functional__ = false
/* styles */
var __vue_styles__ = null
/* scopeId */
var __vue_scopeId__ = null
/* moduleIdentifier (server only) */
var __vue_module_identifier__ = null
var Component = normalizeComponent(
  __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_popup_vue___default.a,
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_508e75ca_hasScoped_false_preserveWhitespace_false_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_popup_vue__["a" /* default */],
  __vue_template_functional__,
  __vue_styles__,
  __vue_scopeId__,
  __vue_module_identifier__
)

/* harmony default export */ __webpack_exports__["default"] = (Component.exports);


/***/ }),

/***/ 42:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;
// not a good way but works well
window.__$Popups = window.__$Popups || {};
var popupDialog = function popupDialog(option) {
  this.uuid = Math.random().toString(36).substring(3, 8);
  this.params = {};
  this.isShow = false;
  if (Object.prototype.toString.call(option) === '[object Object]') {
    this.params = {
      input: option.input || '',
      container: document.querySelector(option.input) || '',
      innerHTML: option.innerHTML || '',
      hideOnBlur: option.hideOnBlur,
      //背景面板
      mask: option.mask,
      onOpen: option.onOpen || function () {},
      onClose: option.onClose || function () {},
      reverse: option.reverse
    };
  }
  if (!!document.querySelectorAll('.popup-mask').length <= 0 && this.params.mask) {
    this.divMask = document.createElement('a');
    this.divMask.className = 'popup-mask';
    this.divMask.dataset.uuid = ''; // 用于多个popup共享一个mask
    this.divMask.href = 'javascript:void(0)';

    this.divMask.addEventListener('touchmove', function (ev) {
      ev.stopPropagation();
      ev.preventDefault();
    });

    document.body.appendChild(this.divMask);
  }
  var div = void 0;
  if (!option.container) {
    div = document.createElement('div');
  } else {
    div = option.container;
  }

  div.className = 'popup-dialog popup-dialog-' + this.uuid;

  this.div = div;

  if (!option.container) {
    document.body.appendChild(div);
  }
  this.container = document.querySelector('.popup-dialog-' + this.uuid);

  if (this.params.mask) {
    this.mask = document.querySelector('.popup-mask');
    this.mask.dataset.uuid += ',' + this.uuid;
  }

  this._bindEvents();
  option = null;
  return this;
};

popupDialog.prototype.onClickMask = function () {
  if (this.params.hideOnBlur && this.isShow) {
    this.hide(false);
  }
};

popupDialog.prototype._bindEvents = function () {
  this.params.mask && this.params.hideOnBlur && this.mask.addEventListener('click', this.onClickMask.bind(this), false);
};

popupDialog.prototype.show = function () {
  if (this.params.reverse) {
    this.container.classList.add('popup-reverse');
  }
  this.params.mask && this.mask.classList.add('popup-show');
  this.container.classList.add('popup-show');
  if (this.container.classList.contains('popup')) {
    this.container.classList.remove('popup');
    this.container.classList.add('popup-dialog');
    this.container.classList.add('popup-dialog' + this.uuid);
  }
  this.params.onOpen && this.params.onOpen(this);
  this.isShow = true;
  window.__$Popups[this.uuid] = 1;
};

popupDialog.prototype.hide = function () {
  var shouldCallback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

  // if (this.params.reverse) {
  //   this.container.classList.remove('popup-reverse')
  // }
  this.container.classList.remove('popup-show');
  if (!document.querySelector('.popup-dialog.popup-show')) {
    this.params.mask && this.mask.classList.remove('popup-show');
  }
  if (this.container.classList.contains('popup')) {
    this.container.classList.remove('popup');
    this.container.classList.add('popup-dialog');
    this.container.classList.add('popup-dialog' + this.uuid);
  }
  shouldCallback === false && this.params.onClose && this.params.hideOnBlur && this.params.onClose(this);
  this.isShow = false;
  delete window.__$Popups[this.uuid];
};

popupDialog.prototype.html = function (html) {
  this.container.innerHTML = html;
};

popupDialog.prototype.destroy = function () {
  if (this.params.mask) {
    this.mask.dataset.uuid = this.mask.dataset.uuid.replace(new RegExp(',' + this.uuid, 'g'), '');
  }
  if (this.params.mask && !this.mask.dataset.uuid) {
    this.mask.removeEventListener('click', this.onClickMask.bind(this), false);
    this.mask && this.mask.parentNode && this.mask.parentNode.removeChild(this.mask);
  } else {
    this.hide();
  }
  delete window.__$Popups[this.uuid];
};

exports.default = popupDialog;

/***/ }),

/***/ 43:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
var render = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('transition',{attrs:{"name":_vm.transitionStyle}},[_c('div',{directives:[{name:"show",rawName:"v-show",value:(_vm.show),expression:"show"}],staticClass:"popupPanel",class:_vm.classes,style:(_vm.styles)},[_vm._t("default")],2)])}
var staticRenderFns = []
var esExports = { render: render, staticRenderFns: staticRenderFns }
/* harmony default export */ __webpack_exports__["a"] = (esExports);

/***/ })

/******/ });