'use strict';

exports.__esModule = true;
exports.initTargetInfo = initTargetInfo;
exports.initIMUserInfo = initIMUserInfo;
exports.initEnvironment = initEnvironment;

var _cookie = require('../../../utils/cookie');

var _cookie2 = _interopRequireDefault(_cookie);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function initTargetInfo(_ref, obj) {
  var state = _ref.state,
      commit = _ref.commit;

  commit('updateTargetInfo', obj);
}

function initIMUserInfo(_ref2, obj) {
  var state = _ref2.state,
      commit = _ref2.commit;

  commit('updateIMUserInfo', obj);
}

function initEnvironment(_ref3, env) {
  var state = _ref3.state,
      commit = _ref3.commit;

  commit('updateEnvironment', env);
}