'use strict';

exports.__esModule = true;

var cookie = {
  //写cookies 
  setCookie: function setCookie(name, value) {
    var days = 1;
    var exp = new Date();
    exp.setTime(exp.getTime() + days * 24 * 60 * 60 * 1000);
    document.cookie = name + '=' + escape(value) + ';expires=' + exp.toGMTString();
  },
  //读取cookies 
  readCookie: function readCookie(name) {
    var arr = null;
    var reg = new RegExp('(^| )' + name + '=([^;]*)(;|$)');
    if (document.cookie && (arr = document.cookie.match(reg))) {
      return unescape(arr[2]);
    } else {
      return null;
    }
  },
  //删除cookies 
  delCookie: function delCookie(name) {
    var cval = this.readCookie(name);
    if (cval != null) {
      document.cookie = name + '=' + cval + ';expires=' + new Date(0).toGMTString();
    }
  }
};

exports.default = cookie;