const Loading = Object.create(null)

let timerA, timerB, timerC;

Loading.tpl = '<div class="loader-system"><div class="line-scale-pulse-out"><div></div><div></div><div></div><div></div><div></div></div></div>'

Loading.install = function(Vue) {
  Vue.loading = this
  Vue.prototype.$loading = this

  this.div = void 0;
  this.count = 0;
}

Loading.show = function() {
  this.count++;

  if (!!this.div) {
    return
  }

  let fragment = document.createDocumentFragment()
  this.div = document.createElement('div')
  this.div.style.position = 'fixed'
  this.div.style.width = '20%'
  this.div.style.left = '40%'
  this.div.style.top = '28%'
  this.div.style.zIndex = '999999'
  this.div.innerHTML = this.tpl
  fragment.appendChild(this.div)
  clearTimeout(timerA)
  timerA = setTimeout(() => {
    document.body.appendChild(fragment)
    clearTimeout(timerC)
    timerC = setTimeout(()=>{
      this.clear()
    },3000)
  }, 300)
}

Loading.hide = function() {
  this.count--;
  // if (this.count == 0) {
    clearTimeout(timerB)
    timerB = setTimeout(() => {
      if(this.count == 0){
        this.div && this.div.remove()
        this.div = void 0
      }
    }, 300)
  // }
}

Loading.clear = function() {
  this.count = 0;
  clearTimeout(timerB)
  clearTimeout(timerA)
  this.div && this.div.remove()
  this.div = void 0
}
export default Loading
