/**
 * 内存数据状态
 */
export default {
  // 目标聊天对象
  target: {},
  // 用户信息对象
  imUserInfo: {},
  // 聊天室sdk实例
  chatroomInsts: {},
  // IM相关
  // NIM SDK 实例
  nim: null,
  // 登录账户ID
  userUID: null,
  // 当前聊天室实例及id
  currChatroom: null,
  currChatroomId: null,
  currChatroomMsgs: [],
  currChatroomInfo: {},
  // 消息列表
  msgs: {}, //以 sessionId作为key
  msgsMap: {}, // 以idClient作为key，诸如消息撤回等的消息查找
  // 会话列表
  sessionlist: [],
  sessionMap: {},
  // 当前会话ID（即当前聊天列表，只有单聊群聊采用，可用于判别）
  currSessionId: null,
  currSessionMsgs: [],
  // 是否有更多历史消息，用于上拉加载更多
  noMoreHistoryMsgs: false,
  // 当前IM环境
  environment:'test',
  // 自定义系统消息
  customSysMsgs:{},
  // 常用语
  commonLanguage:'',
  //聊天对象信息
  targetInfo: {},
  //观察一个状态
  EditPopState:true
}
